#include <malloc.h>
#include <stdio.h>
#include <errno.h>
#include <f2c.h>
#include <math.h>

int zgeev_(char *jobvl, char *jobvr, integer *n, doublecomplex *a, integer *lda,
           doublecomplex *w, doublecomplex *vl, integer *ldvl,
           doublecomplex *vr, integer *ldvr, doublecomplex *work,
           integer *lwork, doublereal *rwork, integer *info);

#if 0
#define DEBUG_read_diagonal
#define DEBUG_read_off_diagonal
#endif

main(int argc, char *argv[])
{
   FILE           *DataFile;
   char           *jobvl = "N\0";
   char           *jobvr = "N\0";
   integer         n;
   doublecomplex **A;
   doublecomplex  *Pointer;
   integer         lda;
   doublecomplex  *Eigenvalue;
   doublecomplex   vl;
   integer         ldvl = 1;
   doublecomplex   vr;
   integer         ldvr = 1;
   doublecomplex  *work;
   integer         lwork;
   doublereal     *rwork;
   integer         info;

   int             i;
   int             j;
   int             Index;

   int             Temp_int;
   int             off_diagonal_count;
   double          Temp_double1;
   double          Temp_double2;
   double          Temp_double3;
   double          Temp_double4;

   double          Max_fabs_Eigenvalue;
   double          Min_fabs_Eigenvalue;
   double          fabs_Eigenvalue;
   int             Max_i;
   int             Min_i;
   doublecomplex   Sum_A_diag;
   doublecomplex   Sum_lambda;

   Sum_A_diag.r = 0.0;
   Sum_A_diag.i = 0.0;

   Sum_lambda.r = 0.0;
   Sum_lambda.i = 0.0;

   if (argc < 2)
   {
      printf("usage: %s <diagonal.dat> <off_diagonal.dat> \n", argv[0]);
      exit(1);
   }
   if ((DataFile = fopen(argv[1], "r\0")) == NULL)
   {
      printf("%s -- Can not open diagonal datafile (%s)\n", argv[0], argv[1]);
      exit(1);
   }

   fscanf(DataFile, "%d%*c", &Temp_int);

   n = Temp_int;
   lda = n;
   
#ifdef DEBUG_read_diagonal
   printf("%d\n", n);
#endif

   if ((A = (doublecomplex **) malloc((sizeof(doublecomplex *) * n))) == NULL)
   {
      printf("A = %lx\n", A);
      perror(argv[0]);
      exit(1);
   }

   if ((Pointer = (doublecomplex *) malloc(sizeof(doublecomplex) * n * lda))
       == NULL)
   {
      printf("2\n");
      perror(argv[0]);
      exit(1);
   }

   for (i = 0, Index = 0; i < lda; i++, Index += n)
   {
      A[i] = &(Pointer[Index]);
      for (j = 0; j < n; j++)
      {
         A[i][j].r = 0.0;
         A[i][j].i = 0.0;
      }
   }

   for (Index = 0; Index < n; Index++)
   {
      fscanf(DataFile, "%d %lf %lf\n", &i, &Temp_double1, &Temp_double2);

      A[Index][Index].r = Temp_double1;
      A[Index][Index].i = Temp_double2;

#ifdef DEBUG_read_diagonal
      printf("%d %.9lf %.9lf\n", i, A[i][i].r, A[i][i].i);
#endif
      Sum_A_diag.r += A[i][i].r;
      Sum_A_diag.i += A[i][i].i;
   }

   fclose(DataFile);

   if ((DataFile = fopen(argv[2], "r")) == NULL)
   {
      printf("%s -- Can not open diagonal datafile (%s)\n", argv[0], argv[2]);
      exit(1);
   }

   fscanf(DataFile, "%d", &off_diagonal_count);

#ifdef DEBUG_read_off_diagonal
   printf("%d\n", n);
#endif

   for (Index = 0; Index < off_diagonal_count; Index++)
   {
      fscanf(DataFile, "%d %d %lf %lf %lf %lf\n", &i, &j,
             &Temp_double1, &Temp_double2, &Temp_double3, &Temp_double4);
      A[j][i].r = Temp_double1;
      A[j][i].i = Temp_double2;
      A[i][j].r = Temp_double3;
      A[i][j].i = Temp_double4;

#ifdef DEBUG_read_off_diagonal
      printf("%d %d %.9lf %.9lf %.9lf %.9lf\n", i, j, A[j][i].r, A[j][i].i,
             A[i][j].r, A[i][j].i);
#endif
   }

   fclose(DataFile);

   if ((Eigenvalue = (doublecomplex *) malloc(sizeof(doublecomplex) * n))
       == NULL)
   {
      perror(argv[0]);
      exit(1);
   }

   lwork = 4 * n * lda;

   if ((work = (doublecomplex *) malloc(sizeof(doublecomplex) * lwork)) == NULL)
   {
      perror(argv[0]);
      exit(1);
   }

   if ((rwork = (doublereal *) malloc(sizeof(doublereal) * 2 * n)) == NULL)
   {
      perror(argv[0]);
      exit(1);
   }

   zgeev_(jobvl, jobvr, &n, A[0], &lda, Eigenvalue, &vl, &ldvl, &vr, &ldvr,
          work, &lwork, rwork, &info);

   printf("info = %d work[1] = %g\n", info, work[1]);

   Max_i = Min_i = i = 0;
   Sum_lambda.r += Eigenvalue[i].r;
   Sum_lambda.i += Eigenvalue[i].i;
   Max_fabs_Eigenvalue = sqrt((Eigenvalue[i].r * Eigenvalue[i].r)
                              + (Eigenvalue[i].i * Eigenvalue[i].i));
   Min_fabs_Eigenvalue = Max_fabs_Eigenvalue;

   printf("Eigenvalue[%d] = (%.9lf, %.9lf) |Eigenvalue[%d]| = %.9lf\n",
          i, Eigenvalue[i].r, Eigenvalue[i].i, i, Max_fabs_Eigenvalue);

   for (i = 1; i < n; i++)
   {
      Sum_lambda.r += Eigenvalue[i].r;
      Sum_lambda.i += Eigenvalue[i].i;
      fabs_Eigenvalue = sqrt((Eigenvalue[i].r * Eigenvalue[i].r)
                             + (Eigenvalue[i].i * Eigenvalue[i].i));

      printf("Eigenvalue[%d] = (%.9lf, %.9lf) |Eigenvalue[%d]| = %.9lf\n",
             i, Eigenvalue[i].r, Eigenvalue[i].i, i, fabs_Eigenvalue);

      if (fabs_Eigenvalue > Max_fabs_Eigenvalue)
      {
         Max_fabs_Eigenvalue = fabs_Eigenvalue;
         Max_i = i;
      }
      else if (fabs_Eigenvalue < Min_fabs_Eigenvalue)
      {
         Min_fabs_Eigenvalue = fabs_Eigenvalue;
         Min_i = i;
      }
   }

   printf("Max Eigenvalue = (%.9lf, %.9lf), |Max Eigenvalue| = %.9lf\n",
          Eigenvalue[Max_i].r, Eigenvalue[Max_i].i, Max_fabs_Eigenvalue);

   printf("Min Eigenvalue = (%.9lf, %.9lf), |Min Eigenvalue| = %.9lf\n",
          Eigenvalue[Min_i].r, Eigenvalue[Min_i].i, Min_fabs_Eigenvalue);

   printf("Matrix Condition number = %.9lf\n",
          Max_fabs_Eigenvalue / Min_fabs_Eigenvalue);

   printf("Sum A[i][i] = (%.9lf, %.9lf), Sum lambdas = (%.9lf, %.9lf)\n",
          Sum_A_diag.r, Sum_A_diag.i, Sum_lambda.r, Sum_lambda.i);
}

